<template>
  <div class="vertical-container">
    <h1>Atchoo - the allergy counter</h1>
    <div>
    <button id="clearNose" @click=sendHappening>Clear Nose</button>
    </div>
    <div>
    <button id="clearThroat" @click=sendHappening>Clear Throat</button>
    </div>
    <div>
    <button id="sneeze" @click=sendHappening>Sneeze</button>
    </div>
  </div>
</template>

<script>
import http from 'http'

export default {
  name: 'counter',
  methods: {
    sendHappening: function (event) {
      const happening = event.target.id
      http.get(window.env['BACKEND_BASE_URL']+'/event/' + happening, (res) => {
        const { statusCode } = res
        const contentType = res.headers['content-type']

        let error
        if (statusCode !== 200) {
          error = new Error('Request Failed.\n' +
                            `Status Code: ${statusCode}`)
        } else if (!/^application\/json/.test(contentType)) {
          error = new Error('Invalid content-type.\n' +
                            `Expected application/json but received ${contentType}`)
        }
        if (error) {
          console.error(error.message)
          // consume response data to free up memory
          res.resume()
          return
        }

        res.setEncoding('utf8')
        let rawData = ''
        res.on('data', (chunk) => { rawData += chunk })
        res.on('end', () => {
          try {
            const parsedData = JSON.parse(rawData)
            console.log(parsedData)
          } catch (e) {
            console.error(e.message)
          }
        })
      }).on('error', (e) => {
        console.error(`Got error: ${e.message}`)
      })
    }
  }
}
</script>

<style scoped>
.vertical-container {
  height: 300px;
  display: -webkit-flex;
  display:         flex;
  -webkit-align-items: center;
          align-items: center;
  -webkit-justify-content: center;
          justify-content: center;
}
h1.vertical-container {
  font-size: 275%;
}
